\section{C++ planner\label{Cpp-planner}}

We have so far described how the general structure of the planners
were chosen. But even though the two languages are very similar, they
are based on different frameworks, and they also have different
options for optimizations. Then off course - we are competing, it
yields differences automatically.

This chapter therefore first takes a look at the specialities of this
system while it also explains the overall architecture of such a
system.

Finally we describe how we convert the solution in to useful actions
that the agent is able to execute.

\subsection{Testing for closed set functionality}
The a$*$ functionality propose that there should be used a closed set
test in order to avoid testing the same situation more than once. 

This functionality can made by using a set which holds all the
different positions. At each iteration of the algorithm, the position
is tested against the set where if its not found, are added to the set
and lets the algorithm continue working on the single node. If its
found, the algorithm skips it and goes on.

As we have the different positions represented as an integer array (see
section \vref{sec:layout}) its simply a question of sorting these (in
that way we neglect the order of the jewels as they are saved in the
program) 

The tricky thing is that these positions are concatenated (by using binary shift operations) 
together in to a 64 bit variable also including the position of the man and his
direction. It is this 64 bit variable that is stored in an 
\verb!std:set<long long>! container from C++ \emph{Standard Template
  Library} (STL) so as long as we can concatenate the problem in a
manner in which it may be presented in less than 64 bits, it will
run. 

% {\color{red}TOBIAS I AM NOT SO SURE WE NEED THIS PART}

\subsection{Layout of the program}\label{sec:layout}

\begin{figure}[ht]
\centering
\rotatebox{-90}{\includegraphics{classes}}
\caption{Basic diagram of the model of the system. As one can see
  the central thing is the algorithm who solves an abstract
  problem. The result is realised in instances of nodes which attach
  themselves to their parents.}\label{fig:cppclasses}
\end{figure}

In the C++ version, we choose a design where we are able to represent
a problem at an abstract level. The specific problem derives from a
\emph{problem} interface which is able to be solved with a generic
algorithm implementation. for illustration, see \vref{fig:cppclasses}.

We could have designed an abstract level for each node to be
implemented for the algorithm, for the sake of good architecture - but
it would not have given us any advanced since we are only using one
node structure anyway.

To represent the world, we designed a \emph{World} class that was
responsible for loading the world in to an array. The world knows the
dimension of this world and therefore is also responsible for choosing
what cells lies around a specific position. It knows the position of
the different walls, so therefore it is only fair if the
responsibility of testing for walls lies here.

At the lowest technical level we have a template class
(\emph{refptr$<$T$>$}) that is responsible for handling memory by
using reference counting. Its just mentioned here for completeness.

\subsection{Conversion to agent motion}

At the point of a completed search of the total problem, it still only
exists as a tree of nodes which only knowledge of each other is by
moving up in the tree.

This order is starting at the goal and moves back towards the initial
state. Therefore the sequence is basically just reversed. But a little
extra work is also performed at this point. The reason for this is the
tree only represent the motion of the man from one cell to another -
we still have to tell the agent that is has to turn left or right. 

We considered at some point to implement a functionality in the agent
so that it only needed to be told in which direction to go (North,
south, east or west)

The result is saved in to a file as a set of textural functions that
is able to be pasted in to the agent program and executed.

\subsection{End result}

For the final demonstration, we were given a final puzzle for out
program to solve. At that time we were not able to solve it with
the C++ algorithm. Instead we had removed a jewel plus a goal and
solved the puzzle without any greater problems.

Since then we have solved the problem and was able to solve the puzzle
on a 1.2 GHz AMD K7 processor in 22m7.341s real time or 19m5.348s in
user time (by real time we mean the time that it actually took on the
clock and user time is the time the OS allocated for the process)

The reason it didn't work at the time of the demonstration is because
of the closed set should be implemented with a 64-bit value, but it
was accidentally only implemented with 32-bits. This coursed some of
the man information to be cut away as it was not able to fit in.
